package com.glxp.mipsdl.admin.http;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.mipsdl.admin.config.ThirdSysConfig;
import com.glxp.mipsdl.admin.req.system.PostFileThrOrderRequest;
import com.glxp.mipsdl.admin.req.system.PostThrCorpRequest;
import com.glxp.mipsdl.admin.req.system.PostThrInvProductsRequest;
import com.glxp.mipsdl.admin.req.system.PostThrProductsRequest;
import com.glxp.mipsdl.admin.util.HttpClient;
import com.glxp.mipsdl.common.res.BaseResponse;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class UdiwmsClient {

    @Resource
    private ThirdSysConfig thirdSysConfig;


    public HttpHeaders getHeaders() {
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/json");
        headers.add("api_key", thirdSysConfig.getThirdSysConfig().getApikey());
        headers.add("secret_key", thirdSysConfig.getThirdSysConfig().getSecretkey());
        return headers;
    }


    public BaseResponse postProducts(PostThrProductsRequest postThrProductsRequest) {
        String response = HttpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + "/udiwms/thrsys/postThrProducts", postThrProductsRequest, getHeaders());
        BaseResponse baseResponse =
                JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                });
        return baseResponse;
    }

    public BaseResponse postCorps(PostThrCorpRequest postThrCorpRequest) {
        postThrCorpRequest.setUploadType("文件导入");
        String response = HttpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + "/udiwms/thrsys/postCorps", postThrCorpRequest, getHeaders());
        BaseResponse baseResponse =
                JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                });
        return baseResponse;
    }

    public BaseResponse postOrderDetail(PostFileThrOrderRequest postFileThrOrderRequest) {
        String response = HttpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + "/udiwms/thrsys/postFileOrder", postFileThrOrderRequest, getHeaders());
        BaseResponse baseResponse =
                JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                });
        return baseResponse;
    }

    public BaseResponse postInvProducts(PostThrInvProductsRequest postThrInvProductsRequest) {
        String response = HttpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + "/udiwms/thrsys/postInvProducts", postThrInvProductsRequest, getHeaders());
        BaseResponse baseResponse =
                JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                });
        return baseResponse;
    }


}
